/** 
 * 안녕하세요 김하영입니다. 오늘 스터디에서 Reduce라는 함수를 발표하게 됬는데요.
 * 리듀스란 이름에서 알 수 있다시피
 * 배열안에 있는 값을 하나로 줄여주는 메서드입니다.
 * 
 * 일단 먼저 한개의 예를 통해 리듀스 함수를 설명하겠습니다.
 * 
 * 숫자로 이루어진 배열이 있고 그 안에 있는 숫자들을 모두 더한 값을 알아야 합니다.
 * 
 * 첫번째 방법으로
 * 반복문을 사용하여 모든 수를 더하는 방법이 있습니다.
 * 
 * 
 * 두번째 방법으로 Reduce 함수를 사용하여 모든 수를 더합니다.
 * 
 * 
 * 리듀스 함수는 인자를 2개를 받는데요. 첫번째로는 리듀서를 받고 두번째로는 초기값을 받습니다.
 * 첫번째 인자값으로 받는 리듀서는 모든 배열안에 있는 값을 인자로 받아 누적하고, 그 누적된 값을 결과로 리턴합니다.
 * 
 * 두번째 인자값으로 초기값을 받는데, 이 값은 생략이 가능한 값입니다.
 * 생략을 할 경우 누적값은 배열의 첫번째 값부터 시작하며, 초기값이 있을 경우 누적값은 초기값부터 시작합니다.
 * 단 빈 배열에서 리듀서를 실행시킬 경우, 배열안에 값이 없으면 TypeError를 발생시킵니다.
 *  
 * 실제로 리듀서가 실행되는 방식을 그림으로 나타내봤습니다.
 * 
 * 누적값은 1부터 시작하며, 현재값은 2이므로 1과 2를 더한 값인 3을 리턴합니다.
 * 그 다음엔 누적값인 3, 현재값인 3을 더해 6을 리턴하고 이 과정을 계속 반복하며
 * 배열을 모두 순회하고 난 다음 결과 값인 15를 리턴합니다.
 * 
 * 하지만 초기값을 지정해줄 경우 누적값은 초기값부터 시작하며 그 이후로 전과 같이 순회하며 15를 리턴합니다.
 * 
 * 
 * 이제 리듀스를 어쩔때 사용해야 되는지 예를 들겠습니다.
 * 
 * 오늘 팔린 과일들이 배열 안에 문자열 형태로 저장되어 있습니다.
 * 하지만 저는 오늘 팔린 과일들의 이름들이 아닌 팔린 과일들의 갯수를 알고 싶습니다.
 * 그럴 때 리듀스를 사용하시면 됩니다.
 * 
 * 데이터의 형태는 이렇습니다.
 * 그리고 저는 리듀스 함수를 통해 팔린 과일들의 갯수를 알아보겠습니다.
 * 
 * 초기값으로 빈 객체를 선언하고,
 * 객체 안에 과일의 키가 없으면, 그 키를 생성하고 값으로 1을 넣습니다.
 * 객체 안에 키가 있으면 그 키의 값을 +1 시킵니다.
 * 마지막으로 그 객체를 리턴합니다.
 * 
 * 그리고 마지막으로 리턴된 값을 보면 오늘 팔린 과일들의 갯수를 알 수 있는 객체가 만들어졌습니다.
 * 
 * 
 * 세번째로는 리듀스 함수를 통해 중첩 배열을 한개의 배열로 펼칠 수 있습니다.
 * concat 혹은 비구조화를 사용하면 되겠죠
 * 
 * 
 * 
*/